import lib.ui.TextElement;
import lib.ui.ReactiveUI;
import kernel.Log;
import util.Debug;
import kernel.ui.WindowManager;
import kernel.net.Net;
import kernel.KernelEvents;

using util.Extender.LambdaExtender;

class Startup {
	static public function main() {
		// OS.sleep(Math.random() * 3); // Native lua call to `sleep`
		Net.instance.init();
		WindowManager.instance.init();
		
		Debug.printBuildInfo();

		exampleUI();

		Log.moveToOutput("top");

		KernelEvents.instance.startEventLoop();
	}

	static function exampleProgramm() {
		var context = WindowManager.instance.createNewContext();

		context.clickSignal.on(data -> {
			context.setCursorPos(data.pos.x,data.pos.y);
			context.write("x");
		});

		context.write("Example programm");
	}

	static function exampleUI() {
		var context = WindowManager.instance.createNewContext();
		var ui = new ReactiveUI(context);

		ui.render([
			new TextElement("Hello world"),
			new TextElement("Hello world",Green,Red),
		]);

		WindowManager.instance.focusContextToOutput(context,"main");
	}
}

